@x  Section  7  Thu Jan 21 14:14:02 1993
@ The calculation is small, but worthwhile.
This is a paper for pedagogical reasons and so
we will be a little more detailed.

@<Calculate the discriminant and solutions@>=
      discriminant = b**2 - 4.0*a*c
      real_part = -b/(2.0*a)
      maybe_part = sqrt(abs(discriminant))/(2.0*a)
@y  Section  7  Thu Jan 21 14:14:02 1993
@ The calculation is small, but worthwhile.
This is a paper for pedagogical reasons and so
we will be a little more detailed.

This section shows the benefit of using |complex| variables
and functions when appropriate.

@<Calculate the discriminant and solutions@>=
      discriminant = b**2 - 4.0*a*c
      z_1 = ( -b + csqrt(cmplx(discriminant,0.0)))/(2.0*a)
      z_2 = ( -b - csqrt(cmplx(discriminant,0.0)))/(2.0*a)
@z  Section  7  Thu Jan 21 14:14:02 1993

@x  Section  8  Thu Jan 21 14:15:35 1993
@ It is rather obvious that we need to declare these variables.
The additional two variables representing the two parts of the
solution are given somewhat descriptive names.

@<Variable declarations@>=
      real discriminant, real_part, maybe_part
@y  Section  8  Thu Jan 21 14:15:35 1993
@ It is rather obvious that we need to declare these variables.
The name of |discriminant| is obvious.  Many books on
complex variables use $z$ as the generic complex variable.
We are following that convention.

@<Variable declarations@>=
      real discriminant
      complex z_1, z_2
@z  Section  8  Thu Jan 21 14:15:35 1993

@x  Section  9  Thu Jan 21 14:17:18 1993
@ We will write the solutions from two different parts of
a simple |if| based upon the value of the |discriminant|.

@<Output the calculated solutions@>=
      if( discriminant .ge. 0.0 ) then
        write(*,'(''The solutions are'',2g13.6)')
     w    real_part+maybe_part, real_part-maybe_part
      else
        write(*,'(''The solutions are'',2(''('',g13.6,''+i'',g13.6,'')''))')
     w    real_part, maybe_part, real_part, -maybe_part
        end if
@y  Section  9  Thu Jan 21 14:17:18 1993
@ We will write the solutions from two different parts of
a simple |if| based upon the value of the |discriminant|.

@<Output the calculated solutions@>=
      if( discriminant .ge. 0.0 ) then
        write(*,'(''The solutions are'',2g13.6)') real(z_1), real(z_2)
      else
        write(*,'(''The solutions are'',2(''('',g13.6,''+i'',g13.6,'')''))') z_1, z_2
        end if
@z  Section  9  Thu Jan 21 14:17:18 1993

